/[gentoo-x86]/eclass/kde4-base.eclass
Gentoo

Diff of /eclass/kde4-base.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.3 Revision 1.85
1# Copyright 2007-2008 Gentoo Foundation 1# Copyright 1999-2010 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.3 2008/02/18 17:00:32 ingmar Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.85 2011/03/16 22:45:30 dilfridge Exp $
4 4
5# @ECLASS: kde4-base.eclass 5# @ECLASS: kde4-base.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# kde@gentoo.org 7# kde@gentoo.org
8# @BLURB: This eclass provides functions for kde 4.0 ebuilds 8# @BLURB: This eclass provides functions for kde 4.X ebuilds
9# @DESCRIPTION: 9# @DESCRIPTION:
10# The kde4-base.eclass provides support for building KDE4 monolithic ebuilds 10# The kde4-base.eclass provides support for building KDE4 based ebuilds
11# and KDE4 applications. 11# and KDE4 applications.
12# 12#
13# NOTE: This eclass uses the SLOT dependencies from EAPI="1" or compatible, 13# NOTE: KDE 4 ebuilds by default define EAPI="2", this can be redefined but
14# hence you must define EAPI="1" in the ebuild, before inheriting any eclasses. 14# eclass will fail with version older than 2.
15 15
16inherit base eutils multilib cmake-utils kde4-functions 16# @ECLASS-VARIABLE: VIRTUALX_REQUIRED
17# @DESCRIPTION:
18# For proper description see virtualx.eclass manpage.
19# Here we redefine default value to be manual, if your package needs virtualx
20# for tests you should proceed with setting VIRTUALX_REQUIRED=test.
21: ${VIRTUALX_REQUIRED:=manual}
17 22
23inherit kde4-functions base virtualx eutils
24
25get_build_type
26if [[ ${BUILD_TYPE} = live ]]; then
27 if [[ ${KDEBASE} = kdevelop ]]; then
28 inherit git
29 else
30 inherit subversion
31 fi
32fi
33
34# @ECLASS-VARIABLE: CMAKE_REQUIRED
35# @DESCRIPTION:
36# Specify if cmake buildsystem is being used. Possible values are 'always' and 'never'.
37# Please note that if it's set to 'never' you need to explicitly override following phases:
38# src_configure, src_compile, src_test and src_install.
39# Defaults to 'always'.
40: ${CMAKE_REQUIRED:=always}
41if [[ ${CMAKE_REQUIRED} = always ]]; then
42 buildsystem_eclass="cmake-utils"
43 export_fns="src_configure src_compile src_test src_install"
44fi
45
46# Verify KDE_MINIMAL (display QA notice in pkg_setup, still we need to fix it here)
47if [[ -n ${KDE_MINIMAL} ]]; then
48 for slot in ${KDE_SLOTS[@]} ${KDE_LIVE_SLOTS[@]}; do
49 [[ ${KDE_MINIMAL} = ${slot} ]] && KDE_MINIMAL_VALID=1 && break
50 done
51 unset slot
52 [[ -z ${KDE_MINIMAL_VALID} ]] && unset KDE_MINIMAL
53else
54 KDE_MINIMAL_VALID=1
55fi
56
57# @ECLASS-VARIABLE: KDE_MINIMAL
58# @DESCRIPTION:
59# This variable is used when KDE_REQUIRED is set, to specify required KDE minimal
60# version for apps to work. Currently defaults to 4.4
61# One may override this variable to raise version requirements.
62# For possible values look at KDE_SLOTS and KDE_LIVE_SLOTS variables.
63# Note that it is fixed to ${SLOT} for kde-base packages.
64KDE_MINIMAL="${KDE_MINIMAL:-4.4}"
65
66# Set slot for packages in kde-base, koffice and kdevelop
67case ${KDEBASE} in
68 kde-base)
69 # Determine SLOT from PVs
70 case ${PV} in
71 *.9999*) SLOT="${PV/.9999*/}" ;; # stable live
72 4.6* | 4.5.[6-9][0-9]*) SLOT="4.6" ;;
73 4.5* | 4.4.[6-9][0-9]*) SLOT="4.5" ;;
74 4.4* | 4.3.[6-9][0-9]*) SLOT="4.4" ;;
75 9999*) SLOT="live" ;; # regular live
76 *) die "Unsupported ${PV}" ;;
77 esac
78 KDE_MINIMAL="${SLOT}"
79 ;;
80 koffice)
81 SLOT="2"
82 ;;
83 kdevelop)
84 if [[ ${BUILD_TYPE} = live ]]; then
85 # @ECLASS-VARIABLE: KDEVELOP_VERSION
86 # @DESCRIPTION:
87 # Specifies KDevelop version. Default is 4.0.0 for tagged packages and 9999 for live packages.
88 # Applies to KDEBASE=kdevelop only.
89 KDEVELOP_VERSION="${KDEVELOP_VERSION:-9999}"
90 # @ECLASS-VARIABLE: KDEVPLATFORM_VERSION
91 # @DESCRIPTION:
92 # Specifies KDevplatform version. Default is 1.0.0 for tagged packages and 9999 for live packages.
93 # Applies to KDEBASE=kdevelop only.
94 KDEVPLATFORM_VERSION="${KDEVPLATFORM_VERSION:-9999}"
95 else
96 case ${PN} in
97 kdevelop|quanta)
98 KDEVELOP_VERSION=${PV}
99 KDEVPLATFORM_VERSION="$(($(get_major_version)-3)).$(get_after_major_version)"
100 ;;
101 kdevplatform)
102 KDEVELOP_VERSION="$(($(get_major_version)+3)).$(get_after_major_version)"
103 KDEVPLATFORM_VERSION=${PV}
104 ;;
105 *)
106 KDEVELOP_VERSION="${KDEVELOP_VERSION:-4.0.0}"
107 KDEVPLATFORM_VERSION="${KDEVPLATFORM_VERSION:-1.0.0}"
108 esac
109 fi
110 SLOT="4"
111 ;;
112esac
113
114slot_is_at_least 4.5 ${KDE_MINIMAL} && CMAKE_MIN_VERSION="2.8.1"
115
116inherit ${buildsystem_eclass}
117
18EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_test src_install pkg_postinst pkg_postrm 118EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare ${export_fns} pkg_postinst pkg_postrm
19 119
20COMMONDEPEND=">=x11-libs/qt-4.3.3:4" 120unset buildsystem_eclass
21DEPEND="${DEPEND} ${COMMONDEPEND} 121unset export_fns
22 >=dev-util/cmake-2.4.7-r1 122
123# @ECLASS-VARIABLE: DECLARATIVE_REQUIRED
124# @DESCRIPTION:
125# Is qt-declarative required? Possible values are 'always', 'optional' and 'never'.
126# This variable must be set before inheriting any eclasses. Defaults to 'never'.
127DECLARATIVE_REQUIRED="${DECLARATIVE_REQUIRED:-never}"
128
129# @ECLASS-VARIABLE: QTHELP_REQUIRED
130# @DESCRIPTION:
131# Is qt-assistant required? Possible values are 'always', 'optional' and 'never'.
132# This variable must be set before inheriting any eclasses. Defaults to 'never'.
133QTHELP_REQUIRED="${QTHELP_REQUIRED:-never}"
134
135# @ECLASS-VARIABLE: OPENGL_REQUIRED
136# @DESCRIPTION:
137# Is qt-opengl required? Possible values are 'always', 'optional' and 'never'.
138# This variable must be set before inheriting any eclasses. Defaults to 'never'.
139OPENGL_REQUIRED="${OPENGL_REQUIRED:-never}"
140
141# @ECLASS-VARIABLE: MULTIMEDIA_REQUIRED
142# @DESCRIPTION:
143# Is qt-multimedia required? Possible values are 'always', 'optional' and 'never'.
144# This variable must be set before inheriting any eclasses. Defaults to 'never'.
145MULTIMEDIA_REQUIRED="${MULTIMEDIA_REQUIRED:-never}"
146
147# @ECLASS-VARIABLE: WEBKIT_REQUIRED
148# @DESCRIPTION:
149# Is qt-webkit requred? Possible values are 'always', 'optional' and 'never'.
150# This variable must be set before inheriting any eclasses. Defaults to 'never'.
151WEBKIT_REQUIRED="${WEBKIT_REQUIRED:-never}"
152
153# @ECLASS-VARIABLE: CPPUNIT_REQUIRED
154# @DESCRIPTION:
155# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'.
156# This variable must be set before inheriting any eclasses. Defaults to 'never'.
157CPPUNIT_REQUIRED="${CPPUNIT_REQUIRED:-never}"
158
159# @ECLASS-VARIABLE: KDE_REQUIRED
160# @DESCRIPTION:
161# Is kde required? Possible values are 'always', 'optional' and 'never'.
162# This variable must be set before inheriting any eclasses. Defaults to 'always'
163# If set to 'always' or 'optional', KDE_MINIMAL may be overriden as well.
164# Note that for kde-base packages this variable is fixed to 'always'.
165KDE_REQUIRED="${KDE_REQUIRED:-always}"
166
167# @ECLASS-VARIABLE: KDE_HANDBOOK
168# @DESCRIPTION:
169# Set to enable handbook in application. Possible values are 'always', 'optional'
170# (handbook USE flag) and 'never'.
171# This variable must be set before inheriting any eclasses. Defaults to 'never'.
172# It adds default handbook dirs for kde-base packages to KMEXTRA and in any case it
173# ensures buildtime and runtime dependencies.
174KDE_HANDBOOK="${KDE_HANDBOOK:-never}"
175
176# Setup packages inheriting this eclass
177case ${KDEBASE} in
178 kde-base)
179 HOMEPAGE="http://www.kde.org/"
180 LICENSE="GPL-2"
181 if [[ $BUILD_TYPE = live ]]; then
182 # Disable tests for live ebuilds
183 RESTRICT+=" test"
184 # Live ebuilds in kde-base default to kdeprefix by default
185 IUSE+=" +kdeprefix"
186 else
187 # All other ebuild types default to -kdeprefix as before
188 IUSE+=" kdeprefix"
189 fi
190 # This code is to prevent portage from searching GENTOO_MIRRORS for
191 # packages that will never be mirrored. (As they only will ever be in
192 # the overlay).
193 case ${PV} in
194 *9999* | 4.?.[6-9]?)
195 RESTRICT+=" mirror"
196 ;;
197 esac
198 # Block installation of other SLOTS unless kdeprefix
199 RDEPEND+=" $(block_other_slots)"
200 ;;
201 koffice)
202 HOMEPAGE="http://www.koffice.org/"
203 LICENSE="GPL-2"
204 ;;
205 kdevelop)
206 HOMEPAGE="http://www.kdevelop.org/"
207 LICENSE="GPL-2"
208 ;;
209esac
210
211# @ECLASS-VARIABLE: QT_MINIMAL
212# @DESCRIPTION:
213# Determine version of qt we enforce as minimal for the package. 4.4.0 4.5.1...
214# 4.6.0 for 4.4, 4.6.3 for 4.5, and 4.7.0 for 4.6 and later
215if slot_is_at_least 4.6 "${KDE_MINIMAL}"; then
216 QT_MINIMAL="${QT_MINIMAL:-4.7.0}"
217elif slot_is_at_least 4.5 "${KDE_MINIMAL}"; then
218 QT_MINIMAL="${QT_MINIMAL:-4.6.3}"
219else
220 QT_MINIMAL="${QT_MINIMAL:-4.6.0}"
221fi
222
223# Declarative dependencies
224qtdeclarativedepend="
225 >=x11-libs/qt-declarative-${QT_MINIMAL}:4
226"
227case ${DECLARATIVE_REQUIRED} in
228 always)
229 COMMONDEPEND+=" ${qtdeclarativedepend}"
230 ;;
231 optional)
232 IUSE+=" declarative"
233 COMMONDEPEND+=" declarative? ( ${qtdeclarativedepend} )"
234 ;;
235 *) ;;
236esac
237unset qtdeclarativedepend
238
239# QtHelp dependencies
240qthelpdepend="
241 >=x11-libs/qt-assistant-${QT_MINIMAL}:4
242"
243case ${QTHELP_REQUIRED} in
244 always)
245 COMMONDEPEND+=" ${qthelpdepend}"
246 ;;
247 optional)
248 IUSE+=" qthelp"
249 COMMONDEPEND+=" qthelp? ( ${qthelpdepend} )"
250 ;;
251esac
252unset qthelpdepend
253
254# OpenGL dependencies
255qtopengldepend="
256 >=x11-libs/qt-opengl-${QT_MINIMAL}:4
257"
258case ${OPENGL_REQUIRED} in
259 always)
260 COMMONDEPEND+=" ${qtopengldepend}"
261 ;;
262 optional)
263 IUSE+=" opengl"
264 COMMONDEPEND+=" opengl? ( ${qtopengldepend} )"
265 ;;
266 *) ;;
267esac
268unset qtopengldepend
269
270# MultiMedia dependencies
271qtmultimediadepend="
272 >=x11-libs/qt-multimedia-${QT_MINIMAL}:4
273"
274case ${MULTIMEDIA_REQUIRED} in
275 always)
276 COMMONDEPEND+=" ${qtmultimediadepend}"
277 ;;
278 optional)
279 IUSE+=" multimedia"
280 COMMONDEPEND+=" multimedia? ( ${qtmultimediadepend} )"
281 ;;
282 *) ;;
283esac
284unset qtmultimediadepend
285
286# WebKit dependencies
287case ${KDE_REQUIRED} in
288 always)
289 qtwebkitusedeps="[kde]"
290 ;;
291 optional)
292 qtwebkitusedeps="[kde?]"
293 ;;
294 *) ;;
295esac
296qtwebkitdepend="
297 >=x11-libs/qt-webkit-${QT_MINIMAL}:4${qtwebkitusedeps}
298"
299unset qtwebkitusedeps
300case ${WEBKIT_REQUIRED} in
301 always)
302 COMMONDEPEND+=" ${qtwebkitdepend}"
303 ;;
304 optional)
305 IUSE+=" webkit"
306 COMMONDEPEND+=" webkit? ( ${qtwebkitdepend} )"
307 ;;
308 *) ;;
309esac
310unset qtwebkitdepend
311
312# CppUnit dependencies
313cppuintdepend="
314 dev-util/cppunit
315"
316case ${CPPUNIT_REQUIRED} in
317 always)
318 DEPEND+=" ${cppuintdepend}"
319 ;;
320 optional)
321 IUSE+=" test"
322 DEPEND+=" test? ( ${cppuintdepend} )"
323 ;;
324 *) ;;
325esac
326unset cppuintdepend
327
328# KDE dependencies
329# Qt accessibility classes are needed in various places, bug 325461
330kdecommondepend="
331 dev-lang/perl
332 >=x11-libs/qt-core-${QT_MINIMAL}:4[qt3support,ssl]
333 >=x11-libs/qt-gui-${QT_MINIMAL}:4[accessibility,dbus]
334 >=x11-libs/qt-qt3support-${QT_MINIMAL}:4[accessibility,kde]
335 >=x11-libs/qt-script-${QT_MINIMAL}:4
336 >=x11-libs/qt-sql-${QT_MINIMAL}:4[qt3support]
337 >=x11-libs/qt-svg-${QT_MINIMAL}:4
338 >=x11-libs/qt-test-${QT_MINIMAL}:4
339 !aqua? (
340 x11-libs/libXext
341 x11-libs/libXt
342 x11-libs/libXxf86vm
343 )
344"
345
346if [[ ${PN} != kdelibs ]]; then
347 kdecommondepend+=" $(add_kdebase_dep kdelibs)"
348 if [[ ${KDEBASE} = kdevelop ]]; then
349 if [[ ${PN} != kdevplatform ]]; then
350 # @ECLASS-VARIABLE: KDEVPLATFORM_REQUIRED
351 # @DESCRIPTION:
352 # Specifies whether kdevplatform is required. Possible values are 'always' (default) and 'never'.
353 # Applies to KDEBASE=kdevelop only.
354 KDEVPLATFORM_REQUIRED="${KDEVPLATFORM_REQUIRED:-always}"
355 case ${KDEVPLATFORM_REQUIRED} in
356 always)
357 kdecommondepend+="
358 >=dev-util/kdevplatform-${KDEVPLATFORM_VERSION}
359 "
360 ;;
361 *) ;;
362 esac
363 fi
364 fi
365fi
366kdedepend="
367 dev-util/automoc
23 dev-util/pkgconfig 368 dev-util/pkgconfig
24 x11-libs/libXt 369 !aqua? (
370 >=x11-libs/libXtst-1.1.0
25 x11-proto/xf86vidmodeproto" 371 x11-proto/xf86vidmodeproto
26RDEPEND="${RDEPEND} ${COMMONDEPEND}" 372 )
373"
374kderdepend=""
27 375
28if has test ${IUSE//+}; then 376if [[ ${PN} != oxygen-icons ]]; then
29 DEPEND="${DEPEND} 377 kderdepend+=" $(add_kdebase_dep oxygen-icons)"
30 test? ( dev-util/cppunit )"
31fi 378fi
32 379
33# @ECLASS-VARIABLE: NEED_KDE 380kdehandbookdepend="
34# @DESCRIPTION: 381 app-text/docbook-xml-dtd:4.2
35# This variable sets the version of KDE4 which will be used by the eclass. 382 app-text/docbook-xsl-stylesheets
36# This variable must be set by the ebuild, for all categories except for "kde-base". 383"
37# For kde-base packages, if it is not set by the ebuild, 384kdehandbookrdepend="
38# it's assumed that the required KDE4 version is the latest, non-live, available. 385 $(add_kdebase_dep kdelibs 'handbook')
39# 386"
40# @CODE 387case ${KDE_HANDBOOK} in
41# Acceptable values are: 388 always)
42# - latest - Use latest version in the portage tree 389 kdedepend+=" ${kdehandbookdepend}"
43# Default for kde-base ebuilds. Banned for ebuilds not part of kde or koffice. 390 [[ ${PN} != kdelibs ]] && kderdepend+=" ${kdehandbookrdepend}"
44# - svn - Use svn release (live ebuilds)
45# - :SLOT - Use any version in the SLOT specified in the NEED_KDE value.
46# - VERSION_NUMBER - Use the minimum KDE4 version specified in the NEED_KDE value.
47# - VERSION_NUMBER:SLOT - Use the minimum KDE4 version and the SLOT specified in the NEED_KDE value.
48# - none - Let the ebuild handle SLOT, kde dependencies, KDEDIR, ...
49# @CODE
50#
51# Note: There is no default NEED_KDE for ebuilds not in kde-base or part of
52# koffice, so you must set it explicitly in the ebuild, in all other cases.
53if [[ -z ${NEED_KDE} ]]; then
54 if [[ -n ${KDEBASE} ]]; then
55 NEED_KDE="latest"
56 else
57 die "kde4-base.eclass inherited but NEED_KDE not defined - broken ebuild"
58 fi
59fi
60export NEED_KDE
61
62case ${NEED_KDE} in
63 latest)
64 # Should only be used by 'kde-base'-ebuilds
65 if [[ "${KDEBASE}" == "kde-base" ]]; then
66 case ${PV} in
67 3.9*) _kdedir="3.9" ;;
68 4*) _kdedir="4.0" ;;
69 *) die "NEED_KDE=latest not supported for PV=${PV}" ;;
70 esac
71 _operator=">="
72 _pv="-${PV}:kde-4"
73 else
74 _kdedir="4.0"
75 _pv=":kde-4"
76 fi
77 ;; 391 ;;
78 svn|9999*|:kde-svn) 392 optional)
79 _kdedir="svn" 393 IUSE+=" +handbook"
80 _pv=":kde-svn" 394 kdedepend+=" handbook? ( ${kdehandbookdepend} )"
81 export NEED_KDE="svn" 395 [[ ${PN} != kdelibs ]] && kderdepend+=" handbook? ( ${kdehandbookrdepend} )"
82 ;; 396 ;;
83 *:kde-svn) 397 *) ;;
84 _kdedir="svn"
85 _operator=">="
86 _pv="-${NEED_KDE}"
87 export NEED_KDE="svn"
88 ;;
89 # The ebuild handles dependencies, KDEDIR, SLOT.
90 none)
91 :
92 ;;
93 # NEED_KDE=":${SLOT}"
94 :kde-4)
95 _kdedir="4.0"
96 _pv="${NEED_KDE}"
97 ;;
98 # NEED_KDE="${PV}:${SLOT}"
99 *:kde-4)
100 _kdedir="4.0"
101 _operator=">="
102 _pv="-${NEED_KDE}"
103 ;;
104 3.9*)
105 _kdedir="3.9"
106 _operator=">="
107 _pv="-${NEED_KDE}:kde-4"
108 ;;
109 4*)
110 _kdedir="4.0"
111 _operator=">="
112 _pv="-${NEED_KDE}:kde-4"
113 ;;
114 *) die "NEED_KDE=${NEED_KDE} currently not supported."
115 ;;
116esac 398esac
399unset kdehandbookdepend kdehandbookrdepend
117 400
118if [[ ${NEED_KDE} != none ]]; then 401case ${KDE_REQUIRED} in
119 KDEDIR="/usr/kde/${_kdedir}" 402 always)
120 KDEDIRS="/usr:/usr/local:${KDEDIR}" 403 IUSE+=" aqua"
404 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" ${kdecommondepend}"
405 [[ -n ${kdedepend} ]] && DEPEND+=" ${kdedepend}"
406 [[ -n ${kderdepend} ]] && RDEPEND+=" ${kderdepend}"
407 ;;
408 optional)
409 IUSE+=" aqua kde"
410 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" kde? ( ${kdecommondepend} )"
411 [[ -n ${kdedepend} ]] && DEPEND+=" kde? ( ${kdedepend} )"
412 [[ -n ${kderdepend} ]] && RDEPEND+=" kde? ( ${kderdepend} )"
413 ;;
414 *) ;;
415esac
121 416
122 if [[ -n ${KDEBASE} ]]; then 417unset kdecommondepend kdedepend kderdepend
123 if [[ ${NEED_KDE} = svn ]]; then
124 SLOT="kde-svn"
125 else
126 SLOT="kde-4"
127 fi
128 fi
129 418
130 # We only need to add the dependencies if ${PN} is not "kdelibs" or "kdepimlibs" 419debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: COMMONDEPEND is ${COMMONDEPEND}"
131 if [[ ${PN} != "kdelibs" ]]; then 420debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: DEPEND (only) is ${DEPEND}"
421debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: RDEPEND (only) is ${RDEPEND}"
422
423# Accumulate dependencies set by this eclass
132 DEPEND="${DEPEND} 424DEPEND+=" ${COMMONDEPEND}"
133 ${_operator}kde-base/kdelibs${_pv}"
134 RDEPEND="${RDEPEND} 425RDEPEND+=" ${COMMONDEPEND}"
135 ${_operator}kde-base/kdelibs${_pv}" 426unset COMMONDEPEND
136 if [[ ${PN} != "kdepimlibs" ]]; then
137 DEPEND="${DEPEND}
138 ${_operator}kde-base/kdepimlibs${_pv}"
139 RDEPEND="${RDEPEND}
140 ${_operator}kde-base/kdepimlibs${_pv}"
141 fi
142 fi
143 427
144 unset _operator _pv _kdedir 428# Add experimental kdeenablefinal, disabled by default
145fi 429IUSE+=" kdeenablefinal"
146 430
147# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a 431# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a
148# koffice ebuild, the URI should be set in the ebuild itself 432# koffice ebuild, the URI should be set in the ebuild itself
149if [[ -n ${KDEBASE} ]]; then 433case ${BUILD_TYPE} in
434 live)
435 SRC_URI=""
436 if has subversion ${INHERITED}; then
437 # Determine branch URL based on live type
438 local branch_prefix
439 case ${PV} in
440 9999*)
441 # trunk
442 branch_prefix="trunk/KDE"
443 ;;
444 *)
445 # branch
446 branch_prefix="branches/KDE/${SLOT}"
447 # @ECLASS-VARIABLE: ESVN_PROJECT_SUFFIX
448 # @DESCRIPTION
449 # Suffix appended to ESVN_PROJECT depending on fetched branch.
450 # Defaults is empty (for -9999 = trunk), and "-${PV}" otherwise.
451 ESVN_PROJECT_SUFFIX="-${PV}"
452 ;;
453 esac
454 # @ECLASS-VARIABLE: ESVN_MIRROR
455 # @DESCRIPTION:
456 # This variable allows easy overriding of default kde mirror service
457 # (anonsvn) with anything else you might want to use.
458 ESVN_MIRROR=${ESVN_MIRROR:=svn://anonsvn.kde.org/home/kde}
459 # Split ebuild, or extragear stuff
150 if [[ -n ${KMNAME} ]]; then 460 if [[ -n ${KMNAME} ]]; then
461 ESVN_PROJECT="${KMNAME}${ESVN_PROJECT_SUFFIX}"
462 if [[ -z ${KMNOMODULE} ]] && [[ -z ${KMMODULE} ]]; then
463 KMMODULE="${PN}"
464 fi
465 # Split kde-base/ ebuilds: (they reside in trunk/KDE)
466 case ${KMNAME} in
467 kdebase-*)
468 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/kdebase/${KMNAME#kdebase-}"
469 ;;
470 kdelibs-*)
471 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/kdelibs/${KMNAME#kdelibs-}"
472 ;;
473 kdereview*)
474 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
475 ;;
476 kdesupport)
477 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
478 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
479 ;;
480 kde*)
481 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/${KMNAME}"
482 ;;
483 extragear*|playground*)
484 # Unpack them in toplevel dir, so that they won't conflict with kde4-meta
485 # build packages from same svn location.
486 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
487 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
488 ;;
489 koffice)
490 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}"
491 ;;
492 *)
493 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
494 ;;
495 esac
496 else
497 # kdelibs, kdepimlibs
498 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/${PN}"
499 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
500 fi
501 # @ECLASS-VARIABLE: ESVN_UP_FREQ
502 # @DESCRIPTION:
503 # This variable is used for specifying the timeout between svn synces
504 # for kde-base and koffice modules. Does not affect misc apps.
505 # Default value is 1 hour.
506 [[ ${KDEBASE} = kde-base || ${KDEBASE} = koffice ]] && ESVN_UP_FREQ=${ESVN_UP_FREQ:-1}
507 elif has git ${INHERITED}; then
508 if [[ -z ${KMNOMODULE} ]] && [[ -z ${KMMODULE} ]]; then
509 KMMODULE="${PN}"
510 fi
511 case ${KDEBASE} in
512 kdevelop)
513 EGIT_REPO_URI="git://git.kde.org/${KMMODULE}"
514 ;;
515 esac
516 fi
517 ;;
518 *)
519 if [[ -n ${KDEBASE} ]]; then
520 if [[ -n ${KMNAME} ]]; then
521 case ${KMNAME} in
522 kdebase-apps)
523 _kmname="kdebase" ;;
524 *)
151 _kmname=${KMNAME} 525 _kmname="${KMNAME}" ;;
526 esac
527 else
528 _kmname=${PN}
529 fi
530 _kmname_pv="${_kmname}-${PV}"
531 case ${KDEBASE} in
532 kde-base)
533 case ${PV} in
534 4.5.93)
535 # Only kdepim and kdepim-runtime 4.6beta here
536 SRC_URI="mirror://kde/unstable/kdepim/${PV}/${_kmname}-4.6beta3.tar.bz2"
537 ;;
538 4.[456].8[05] | 4.[456].9[023568])
539 # Unstable KDE SC releases
540 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.bz2"
541 ;;
542 4.4.6 | 4.4.7 | 4.4.8 | 4.4.9 | 4.4.10)
543 # Only kdepim here
544 SRC_URI="mirror://kde/stable/kdepim-${PV}/src/${_kmname_pv}.tar.bz2"
545 ;;
546 *)
547 # Stable KDE SC releases
548 SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2"
549 ;;
550 esac
551 ;;
552 koffice)
553 case ${PV} in
554 2.1.[6-9]*) SRC_URI="mirror://kde/unstable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;;
555 *) SRC_URI="mirror://kde/stable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;;
556 esac
557 ;;
558 kdevelop)
559 SRC_URI="mirror://kde/stable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.bz2"
560 ;;
561 esac
562 unset _kmname _kmname_pv
563 fi
564 ;;
565esac
566
567debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}"
568
569# @ECLASS-VARIABLE: PREFIX
570# @DESCRIPTION:
571# Set the installation PREFIX for non kde-base applications. It defaults to /usr.
572# kde-base packages go into KDE4 installation directory (KDEDIR) by default.
573# No matter the PREFIX, package will be built against KDE installed in KDEDIR.
574
575# @FUNCTION: kde4-base_pkg_setup
576# @DESCRIPTION:
577# Do the basic kdeprefix KDEDIR settings and determine with which kde should
578# optional applications link
579kde4-base_pkg_setup() {
580 debug-print-function ${FUNCNAME} "$@"
581
582 # Prefix compat:
583 if [[ ${EAPI} == 2 ]] && ! use prefix; then
584 EPREFIX=
585 EROOT=${ROOT}
586 fi
587
588 # Append missing trailing slash character
589 [[ ${EROOT} = */ ]] || EROOT+="/"
590
591 # QA ebuilds
592 [[ -z ${KDE_MINIMAL_VALID} ]] && ewarn "QA Notice: ignoring invalid KDE_MINIMAL (defaulting to ${KDE_MINIMAL})."
593
594 # Don't set KDEHOME during compilation, it will cause access violations
595 unset KDEHOME
596
597 if [[ ${KDEBASE} = kde-base ]]; then
598 if use kdeprefix; then
599 KDEDIR=/usr/kde/${SLOT}
600 else
601 KDEDIR=/usr
602 fi
603 : ${PREFIX:=${KDEDIR}}
152 else 604 else
153 _kmname=${PN} 605 # Determine KDEDIR by loooking for the closest match with KDE_MINIMAL
606 KDEDIR=
607 local kde_minimal_met
608 for slot in ${KDE_SLOTS[@]} ${KDE_LIVE_SLOTS[@]}; do
609 [[ -z ${kde_minimal_met} ]] && [[ ${slot} = ${KDE_MINIMAL} ]] && kde_minimal_met=1
610 if [[ -n ${kde_minimal_met} ]] && has_version "kde-base/kdelibs:${slot}"; then
611 if has_version "kde-base/kdelibs:${slot}[kdeprefix]"; then
612 KDEDIR=/usr/kde/${slot}
613 else
614 KDEDIR=/usr
615 fi
616 break;
617 fi
618 done
619 unset slot
620
621 # Bail out if kdelibs required but not found
622 if [[ ${KDE_REQUIRED} = always ]] || { [[ ${KDE_REQUIRED} = optional ]] && use kde; }; then
623 [[ -z ${KDEDIR} ]] && die "Failed to determine KDEDIR!"
624 else
625 [[ -z ${KDEDIR} ]] && KDEDIR=/usr
154 fi 626 fi
155 _kmname_pv="${_kmname}-${PV}" 627
156 if [[ ${NEED_KDE} != "svn" ]]; then 628 : ${PREFIX:=/usr}
157 case ${KDEBASE} in 629 fi
158 kde-base) 630 EKDEDIR=${EPREFIX}${KDEDIR}
631
632 # Point pkg-config path to KDE *.pc files
633 export PKG_CONFIG_PATH="${EKDEDIR}/$(get_libdir)/pkgconfig${PKG_CONFIG_PATH:+:${PKG_CONFIG_PATH}}"
634 # Point to correct QT plugins path
635 QT_PLUGIN_PATH="${EKDEDIR}/$(get_libdir)/kde4/plugins/"
636
637 # Fix XDG collision with sandbox
638 export XDG_CONFIG_HOME="${T}"
639}
640
641# @FUNCTION: kde4-base_src_unpack
642# @DESCRIPTION:
643# This function unpacks the source tarballs for KDE4 applications.
644kde4-base_src_unpack() {
645 debug-print-function ${FUNCNAME} "$@"
646
647 if [[ ${BUILD_TYPE} = live ]]; then
648 if has subversion ${INHERITED}; then
649 migrate_store_dir
650 subversion_src_unpack
651 elif has git ${INHERITED}; then
652 git_src_unpack
653 fi
654 elif [[ ${EAPI} == 2 ]]; then
655 local file
656 for file in ${A}; do
657 # This setup is because EAPI <= 2 cannot unpack *.tar.xz files
658 # directly, so we do it ourselves (using the exact same code as portage)
159 case ${PV} in 659 case ${file} in
160 *) SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2";; 660 *.tar.xz)
661 echo ">>> Unpacking ${file} to ${PWD}"
662 xz -dc "${DISTDIR}"/${file} | tar xof -
663 assert "failed unpacking ${file}"
664 ;;
665 *)
666 unpack ${file}
667 ;;
161 esac 668 esac
162 ;;
163 koffice)
164 SRC_URI="mirror://kde/unstable/${_kmname_pv}/src/${_kmname_pv}.tar.bz2"
165 ;;
166 esac
167 fi
168 unset _kmname _kmname_pv
169fi
170
171debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}"
172debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: DEPEND ${DEPEND} - before blockers"
173
174# Monolithic ebuilds should add blockers for split ebuilds in the same slot.
175# If KMNAME is not set then this is not a split package
176if [[ -n ${KDEBASE} && -z ${KMNAME} ]]; then
177 for _x in $(get-child-packages ${CATEGORY}/${PN}); do
178 DEPEND="${DEPEND} !${_x}:${SLOT}"
179 RDEPEND="${RDEPEND} !${_x}:${SLOT}"
180 done 669 done
181 unset _x
182fi
183
184debug-print "${BASH_SOURCE} ${LINENO} ${ECLASS} ${FUNCNAME}: DEPEND ${DEPEND} - after blockers"
185
186# @ECLASS-VARIABLE: PREFIX
187# @DESCRIPTION:
188# Set the installation PREFIX. All kde-base ebuilds go into the KDE4 installation directory.
189# Applications installed by the other ebuilds go into /usr/ by default, this value
190# can be superseded by defining PREFIX before inheriting kde4-base.
191if [[ -n ${KDEBASE} ]]; then
192 PREFIX=${KDEDIR}
193else 670 else
194 # if PREFIX is not defined we set it to the default value of /usr 671 # For EAPI >= 3, we can just use unpack() directly
195 PREFIX="${PREFIX:-/usr}" 672 unpack ${A}
196fi 673 fi
674}
197 675
198debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SLOT ${SLOT} - KDEDIR ${KDEDIR} - KDEDIRS ${KDEDIRS}- PREFIX ${PREFIX} - NEED_KDE ${NEED_KDE}"
199
200# @FUNCTION: kde4-base_pkg_setup 676# @FUNCTION: kde4-base_src_prepare
201# @DESCRIPTION: 677# @DESCRIPTION:
202# Adds flags needed by all of KDE 4 to $QT4_BUILT_WITH_USE_CHECK. Uses 678# General pre-configure and pre-compile function for KDE4 applications.
203# kde4-functions_check_use from kde4-functions.eclass to print appropriate 679# It also handles translations if KDE_LINGUAS is defined. See KDE_LINGUAS and
204# errors and die if any required flags listed in $QT4_BUILT_WITH_USE_CHECK or 680# enable_selected_linguas() and enable_selected_doc_linguas()
205# $KDE4_BUILT_WITH_USE_CHECK are missing. 681# in kde4-functions.eclass(5) for further details.
206kde4-base_pkg_setup() { 682kde4-base_src_prepare() {
207 debug-print-function $FUNCNAME "$@" 683 debug-print-function ${FUNCNAME} "$@"
208 684
209 # KDE4 applications require qt4 compiled with USE="accessibility dbus gif jpeg png qt3support ssl zlib". 685 # Only enable selected languages, used for KDE extragear apps.
210 QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} accessibility dbus gif jpeg png qt3support ssl zlib" 686 if [[ -n ${KDE_LINGUAS} ]]; then
687 enable_selected_linguas
688 fi
689
690 # Enable/disable handbooks for kde4-base packages
691 # kde-l10n inherits kde4-base but is metpackage, so no check for doc
692 # kdelibs inherits kde4-base but handle installing the handbook itself
693 if ! has kde4-meta ${INHERITED}; then
694 has handbook ${IUSE//+} && [[ ${PN} != kde-l10n ]] && [[ ${PN} != kdelibs ]] && enable_selected_doc_linguas
695 fi
696
697 # SCM bootstrap
698 if [[ ${BUILD_TYPE} = live ]]; then
699 if has subversion ${INHERITED}; then
700 subversion_src_prepare
701 elif has git ${INHERITED}; then
702 git_src_prepare
703 fi
704 fi
705
706 # Apply patches
707 base_src_prepare
708
709 # Save library dependencies
710 if [[ -n ${KMSAVELIBS} ]] ; then
711 save_library_dependencies
712 fi
713
714 # Inject library dependencies
715 if [[ -n ${KMLOADLIBS} ]] ; then
716 load_library_dependencies
717 fi
718
719 # Replace KDE4Workspace library targets
720 find "${S}" -name CMakeLists.txt \
721 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_TASKMANAGER_(LIBRARY|LIBS)\}/taskmanager/g' {} + \
722 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KWORKSPACE_(LIBRARY|LIBS)\}/kworkspace/g' {} + \
723 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_SOLIDCONTROLIFACES_(LIBRARY|LIBS)\}/solidcontrolifaces/g' {} + \
724 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_SOLIDCONTROL_(LIBRARY|LIBS)\}/solidcontrol/g' {} + \
725 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_PROCESSUI_(LIBRARY|LIBS)\}/processui/g' {} + \
726 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_LSOFUI_(LIBRARY|LIBS)\}/lsofui/g' {} + \
727 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_PLASMACLOCK_(LIBRARY|LIBS)\}/plasmaclock/g' {} + \
728 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_NEPOMUKQUERYCLIENT_(LIBRARY|LIBS)\}/nepomukqueryclient/g' {} + \
729 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_NEPOMUKQUERY_(LIBRARY|LIBS)\}/nepomukquery/g' {} + \
730 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KSCREENSAVER_(LIBRARY|LIBS)\}/kscreensaver/g' {} + \
731 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_WEATHERION_(LIBRARY|LIBS)\}/weather_ion/g' {} + \
732 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KWINEFFECTS_(LIBRARY|LIBS)\}/kwineffects/g' {} + \
733 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KDECORATIONS_(LIBRARY|LIBS)\}/kdecorations/g' {} + \
734 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KSGRD_(LIBRARY|LIBS)\}/ksgrd/g' {} + \
735 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KEPHAL_(LIBRARY|LIBS)\}/kephal/g' {} + \
736 || die 'failed to replace KDE4Workspace library targets'
737
738 # Hack for manuals relying on outdated DTD, only outside kde-base/koffice/...
739 if [[ -z ${KDEBASE} ]]; then
740 find "${S}" -name "*.docbook" \
741 -exec sed -i -r \
742 -e 's:-//KDE//DTD DocBook XML V4\.1(\..)?-Based Variant V1\.[01]//EN:-//KDE//DTD DocBook XML V4.2-Based Variant V1.1//EN:g' {} + \
743 || die 'failed to fix DocBook variant version'
744 fi
745}
746
747# @FUNCTION: kde4-base_src_configure
748# @DESCRIPTION:
749# Function for configuring the build of KDE4 applications.
750kde4-base_src_configure() {
751 debug-print-function ${FUNCNAME} "$@"
752
753 # Build tests in src_test only, where we override this value
754 local cmakeargs=(-DKDE4_BUILD_TESTS=OFF)
755
756 if has kdeenablefinal ${IUSE//+} && use kdeenablefinal; then
757 cmakeargs+=(-DKDE4_ENABLE_FINAL=ON)
758 fi
211 759
212 if has debug ${IUSE//+} && use debug; then 760 if has debug ${IUSE//+} && use debug; then
213 QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} debug" 761 # Set "real" debug mode
214 fi 762 CMAKE_BUILD_TYPE="Debugfull"
215
216 if has opengl ${IUSE//+} && use opengl; then
217 QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} opengl"
218 fi
219
220 kde4-functions_check_use
221}
222
223# @FUNCTION: kde4-base_src_unpack
224# @DESCRIPTION:
225# This function unpacks the source tarballs for KDE4 applications.
226#
227# If no argument is passed to this function, then standard src_unpack is
228# executed. Otherwise options are passed to base_src_unpack.
229#
230# If the directory ${WORKDIR}/patches/ exists, we apply all patches in that
231# directory, provided they follow this format:
232# @CODE
233# - Monolithic ebuilds, (from kde-base)
234# - $CATEGORY=kde-base:
235# Apply ${CHILD_EBUILD_NAME}-${SLOT}-*{diff,patch}
236# - $CATEGORY=!kde-base:
237# Apply ${CHILD_EBUILD_NAME}-${PV}-*{diff,patch}
238# - Split ebuilds:
239# - $CATEGORY=kde-base:
240# Apply ${PN}-${SLOT}-*{diff,patch}
241# - $CATEGORY!=kde-base:
242# Apply ${PN}-${PV}-*{diff,patch}
243# @CODE
244#
245# If ${PATCHES} is non-zero all patches in it gets applied.
246kde4-base_src_unpack() {
247 debug-print-function $FUNCNAME "$@"
248
249 [[ -z "${KDE_S}" ]] && KDE_S="${S}"
250
251 local _patchdir _packages _p
252 _patchdir="${WORKDIR}/patches/"
253 if [[ -z $* ]]; then
254 # Unpack first and deal with KDE patches after examing possible patch sets.
255 # To be picked up, patches need to conform to the guidelines stated before.
256 # Monolithic ebuilds will use the split ebuild patches.
257 [[ -d "${KDE_S}" ]] || unpack ${A}
258 if [[ -d "${_patchdir}" ]]; then
259 if is-parent-package ${CATEGORY}/${PN} ; then
260 _packages="$(get-child-packages ${CATEGORY}/${PN})"
261 _packages="${_packages//${CATEGORY}\//} ${PN}"
262 else
263 _packages="${PN}"
264 fi
265 for _p in ${_packages}; do
266 PATCHES="${PATCHES} $(ls ${_patchdir}/${_p}-${PV}-*{diff,patch} 2>/dev/null)"
267 if [[ -n "${KDEBASE}" ]]; then
268 PATCHES="${PATCHES} $(ls ${_patchdir}/${_p}-${SLOT}-*{diff,patch} 2>/dev/null)"
269 fi
270 done
271 fi
272 [[ -n ${PATCHES} ]] && base_src_unpack autopatch
273 else 763 else
274 # Call base_src_unpack, which unpacks and patches 764 # Handle common release builds
275 # step by step transparently as defined in the ebuild. 765 append-cppflags -DQT_NO_DEBUG
276 base_src_unpack $*
277 fi 766 fi
278 767
279 # Updated cmake dir 768 # Set distribution name
280 if [[ -d "${WORKDIR}/cmake" ]] && [[ -d "${KDE_S}/cmake" ]]; then 769 [[ ${PN} = kdelibs ]] && cmakeargs+=(-DKDE_DISTRIBUTION_TEXT=Gentoo)
281 ebegin "Updating cmake/ directory..." 770
282 rm -rf "${KDE_S}/cmake" || die "Unable to remove old cmake/ directory" 771 # Here we set the install prefix
283 ln -s "${WORKDIR}/cmake" "${KDE_S}/cmake" || die "Unable to symlink the new cmake/ directory" 772 tc-is-cross-compiler || cmakeargs+=(-DCMAKE_INSTALL_PREFIX="${EPREFIX}${PREFIX}")
284 eend 0 773
774 # Use colors
775 QTEST_COLORED=1
776
777 # Shadow existing /usr installations
778 unset KDEDIRS
779
780 # Handle kdeprefix-ed KDE
781 if [[ ${KDEDIR} != /usr ]]; then
782 # Override some environment variables - only when kdeprefix is different,
783 # to not break ccache/distcc
784 PATH="${EKDEDIR}/bin:${PATH}"
785
786 # Append library search path
787 append-ldflags -L"${EKDEDIR}/$(get_libdir)"
788
789 # Append full RPATH
790 cmakeargs+=(-DCMAKE_SKIP_RPATH=OFF)
791
792 # Set cmake prefixes to allow buildsystem to locate valid KDE installation
793 # when more are present
794 cmakeargs+=(-DCMAKE_SYSTEM_PREFIX_PATH="${EKDEDIR}")
285 fi 795 fi
796
797 #qmake -query QT_INSTALL_LIBS unavailable when cross-compiling
798 tc-is-cross-compiler && cmakeargs+=(-DQT_LIBRARY_DIR=${ROOT}/usr/lib/qt4)
799 #kde-config -path data unavailable when cross-compiling
800 tc-is-cross-compiler && cmakeargs+=(-DKDE4_DATA_DIR=${ROOT}/usr/share/apps/)
801
802 # Handle kdeprefix in application itself
803 if ! has kdeprefix ${IUSE//+} || ! use kdeprefix; then
804 # If prefix is /usr, sysconf needs to be /etc, not /usr/etc
805 cmakeargs+=(-DSYSCONF_INSTALL_DIR="${EPREFIX}"/etc)
806 fi
807
808 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then
809 mycmakeargs=(${mycmakeargs})
810 fi
811
812 mycmakeargs=("${cmakeargs[@]}" "${mycmakeargs[@]}")
813
814 cmake-utils_src_configure
286} 815}
287 816
288# @FUNCTION: kde4-base_src_compile 817# @FUNCTION: kde4-base_src_compile
289# @DESCRIPTION: 818# @DESCRIPTION:
290# General function for compiling KDE4 applications. 819# General function for compiling KDE4 applications.
291kde4-base_src_compile() { 820kde4-base_src_compile() {
292 debug-print-function ${FUNCNAME} "$@" 821 debug-print-function ${FUNCNAME} "$@"
293 822
294 kde4-base_src_configure
295 kde4-base_src_make
296}
297
298# @FUNCTION: kde4-base_src_configure
299# @DESCRIPTION:
300# Function for configuring the build of KDE4 applications.
301kde4-base_src_configure() {
302 debug-print-function ${FUNCNAME} "$@"
303
304 # Final flag handling
305 if has kdeenablefinal ${IUSE//+} && use kdeenablefinal; then
306 einfo "Activating enable-final flag"
307 mycmakeargs="${mycmakeargs} -DKDE4_ENABLE_FINAL=ON"
308 fi
309
310 # Enable generation of HTML handbook
311 if has htmlhandbook ${IUSE//+} && use htmlhandbook; then
312 einfo "Enabling building of HTML handbook"
313 mycmakeargs="${mycmakeargs} -DKDE4_ENABLE_HTMLHANDBOOK=ON"
314 fi
315
316 # Build tests in src_test only, where we override this value
317 mycmakeargs="${mycmakeargs} -DKDE4_BUILD_TESTS=OFF"
318
319 # Set distribution name
320 [[ ${PN} == "kdelibs" ]] && mycmakeargs="${mycmakeargs} -DKDE_DISTRIBUTION_TEXT=Gentoo"
321
322 # runpath linking
323 mycmakeargs="${mycmakeargs} -DKDE4_USE_ALWAYS_FULL_RPATH=ON"
324
325 # Here we set the install prefix
326 mycmakeargs="${mycmakeargs} -DCMAKE_INSTALL_PREFIX=${PREFIX}"
327
328 # Set environment
329 QTEST_COLORED=1
330 QT_PLUGIN_PATH=${KDEDIR}/$(get_libdir)/kde4/plugins/
331
332 cmake-utils_src_configureout
333}
334
335# @FUNCTION: kde4-base_src_make
336# @DESCRIPTION:
337# Function for building KDE4 applications.
338# Options are passed to cmake-utils_src_make.
339kde4-base_src_make() {
340 debug-print-function ${FUNCNAME} "$@"
341
342 cmake-utils_src_make "$@" 823 cmake-utils_src_compile "$@"
343} 824}
344 825
345# @FUNCTION: kde4-base_src_test 826# @FUNCTION: kde4-base_src_test
346# @DESCRIPTION: 827# @DESCRIPTION:
347# Function for testing KDE4 applications. 828# Function for testing KDE4 applications.
348kde4-base_src_test() { 829kde4-base_src_test() {
349 debug-print-function ${FUNCNAME} "$@" 830 debug-print-function ${FUNCNAME} "$@"
350 831
351 # Override this value, set in kde4-base_src_configure() 832 # Override this value, set in kde4-base_src_configure()
352 mycmakeargs="${mycmakeargs} -DKDE4_BUILD_TESTS=ON" 833 mycmakeargs+=(-DKDE4_BUILD_TESTS=ON)
353 cmake-utils_src_compile 834 cmake-utils_src_configure
835 kde4-base_src_compile
354 836
837 # When run as normal user during ebuild development with the ebuild command, the
838 # kde tests tend to access the session DBUS. This however is not possible in a real
839 # emerge or on the tinderbox.
840 # > make sure it does not happen, so bad tests can be recognized and disabled
841 unset DBUS_SESSION_BUS_ADDRESS
842
843 if [[ ${VIRTUALX_REQUIRED} == always || ${VIRTUALX_REQUIRED} == test ]]; then
844 # check for sanity if anyone already redefined VIRTUALX_COMMAND from the default
845 if [[ ${VIRTUALX_COMMAND} != "emake" ]]; then
846 # surprise- we are already INSIDE virtualmake!!!
847 debug-print "QA Notice: This version of kde4-base.eclass includes the virtualx functionality."
848 debug-print " You may NOT set VIRTUALX_COMMAND or call virtualmake from the ebuild."
849 debug-print " Setting VIRTUALX_REQUIRED is completely sufficient. See the"
850 debug-print " kde4-base.eclass docs for details... Applying workaround."
851 cmake-utils_src_test
852 else
853 VIRTUALX_COMMAND="cmake-utils_src_test" virtualmake
854 fi
855 else
355 cmake-utils_src_test 856 cmake-utils_src_test
857 fi
356} 858}
357 859
358# @FUNCTION: kde4-base_src_install 860# @FUNCTION: kde4-base_src_install
359# @DESCRIPTION: 861# @DESCRIPTION:
360# Function for installing KDE4 applications. 862# Function for installing KDE4 applications.
361kde4-base_src_install() { 863kde4-base_src_install() {
362 debug-print-function ${FUNCNAME} "$@" 864 debug-print-function ${FUNCNAME} "$@"
363 865
364 kde4-base_src_make_doc 866 # Prefix support, for usage in ebuilds
867 if [[ ${EAPI} == 2 ]] && ! use prefix; then
868 ED=${D}
869 fi
870
871 if [[ -n ${KMSAVELIBS} ]] ; then
872 install_library_dependencies
873 fi
874
875 # Install common documentation of KDE4 applications
876 local doc
877 if ! has kde4-meta ${INHERITED}; then
878 for doc in "${S}"/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
879 [[ -f "${doc}" ]] && [[ -s "${doc}" ]] && dodoc "${doc}"
880 done
881 for doc in "${S}"/*/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
882 [[ -f "${doc}" ]] && [[ -s "${doc}" ]] && newdoc "${doc}" "$(basename $(dirname ${doc})).$(basename ${doc})"
883 done
884 fi
885
365 cmake-utils_src_install 886 cmake-utils_src_install
366} 887}
367 888
368# @FUNCTION: kde4-base_src_make_doc
369# @DESCRIPTION:
370# Function for installing the documentation of KDE4 applications.
371kde4-base_src_make_doc() {
372 debug-print-function ${FUNCNAME} "$@"
373
374 local doc
375 for doc in AUTHORS ChangeLog* README* NEWS TODO; do
376 [[ -s $doc ]] && dodoc ${doc}
377 done
378
379 if [[ -z ${KMNAME} ]]; then
380 for doc in {apps,runtime,workspace,.}/*/{AUTHORS,README*}; do
381 if [[ -s $doc ]]; then
382 local doc_complete=${doc}
383 doc="${doc#*/}"
384 newdoc "$doc_complete" "${doc%/*}.${doc##*/}"
385 fi
386 done
387 fi
388
389 if [[ -n ${KDEBASE} && -d "${D}"/usr/share/doc/${PF} ]]; then
390 # work around bug #97196
391 dodir /usr/share/doc/kde && \
392 mv "${D}"/usr/share/doc/${PF} "${D}"/usr/share/doc/kde/ || \
393 die "Failed to move docs to kde/ failed."
394 fi
395}
396
397# @FUNCTION: kde4-base_pkg_postinst 889# @FUNCTION: kde4-base_pkg_postinst
398# @DESCRIPTION: 890# @DESCRIPTION:
399# Function to rebuild the KDE System Configuration Cache after an application has been installed. 891# Function to rebuild the KDE System Configuration Cache after an application has been installed.
400kde4-base_pkg_postinst() { 892kde4-base_pkg_postinst() {
893 debug-print-function ${FUNCNAME} "$@"
894
895 buildsycoca
896
897 if [[ ${BUILD_TYPE} = live ]] && [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
898 echo
899 einfo "WARNING! This is an experimental live ebuild of ${CATEGORY}/${PN}"
900 einfo "Use it at your own risk."
901 einfo "Do _NOT_ file bugs at bugs.gentoo.org because of this ebuild!"
902 echo
903 elif [[ ${BUILD_TYPE} != live ]] && [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]] && has kdeprefix ${IUSE//+} && use kdeprefix; then
904 # warning about kdeprefix for non-live users
905 echo
906 ewarn "WARNING! You have the kdeprefix useflag enabled."
907 ewarn "This setting is strongly discouraged and might lead to potential trouble"
908 ewarn "with KDE update strategies."
909 ewarn "You are using this setup at your own risk and the kde team does not"
910 ewarn "take responsibilities for dead kittens."
911 echo
912 fi
913 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]] && ! has_version 'kde-base/kdebase-runtime-meta' && ! has_version 'kde-base/kdebase-startkde'; then
914 # warn about not supported approach
915 if [[ ${KDE_REQUIRED} == always ]] || ( [[ ${KDE_REQUIRED} == optional ]] && use kde ); then
916 echo
917 ewarn "WARNING! Your system configuration contains neither \"kde-base/kdebase-runtime-meta\""
918 ewarn "nor \"kde-base/kdebase-startkde\". You need one of above."
919 ewarn "With this setting you are unsupported by KDE team."
920 ewarn "All missing features you report for misc packages will be probably ignored or closed as INVALID."
921 fi
922 fi
923}
924
925# @FUNCTION: kde4-base_pkg_postrm
926# @DESCRIPTION:
927# Function to rebuild the KDE System Configuration Cache after an application has been removed.
928kde4-base_pkg_postrm() {
929 debug-print-function ${FUNCNAME} "$@"
930
401 buildsycoca 931 buildsycoca
402} 932}
403
404# @FUNCTION: kde4-base_pkg_postrm
405# @DESCRIPTION:
406# Function to rebuild the KDE System Configuration Cache after an application has been removed.
407kde4-base_pkg_postrm() {
408 buildsycoca
409}

Legend:
Removed from v.1.3  
changed lines
  Added in v.1.85

  ViewVC Help
Powered by ViewVC 1.1.20